
Redmine - Patch #31076

Issues CSV / PDF export via ActiveJob

2019-03-21 11:35 - Jens Krämer

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: Candidate for next major release   

Description

Why?

Exporting large amounts of issues and/or issues with a lot of custom fields as CSV or PDF can take a long time, to the point where

users run into HTTP timeouts and cannot successfully do their exports.

How?

This patch which has been extracted from Planio allows for such exports to be run in a queueing backend like DelayedJob (that's

what we use, but any supported ActiveJob backend should be fine). Exports with less than 1000 issues or exports that take less than

30 seconds to finish will be delivered to the user immediately as a download (just as it is without this patch), but after 30 seconds, the

controller gives up waiting and returns the user to the previous issues listing. An email with a download link will be sent to the user

once the export is finished.

Without a configured ActiveJob backend everything will be as before and all exports are processed in-request.  The background

export logic itself is generic and we use the same approach for running time entry exports in the background as well. I'll post that as a

separate patch if there's interest in integrating this into Redmine at all.

Patches are against current master. Patch no 1 adds a lazy_issues method to IssueQuery which fetches issues in batches (to avoid

high memory usage). Patch no 2 implements the background execution.

Related issues:

Related to Redmine - Feature #24477: CSV export feature for thousand of issues New

Related to Redmine - Defect #24473: CSV Export Very slow for issues with lots... New

Related to Redmine - Feature #36691: Background job and dedicated status for ... Closed

History

#1 - 2019-03-21 11:36 - Jens Krämer

related to #24477, #24473

#2 - 2019-03-21 12:12 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2019-03-21 12:36 - Go MAEDA

- Related to Feature #24477: CSV export feature for thousand of issues added

#4 - 2019-03-21 12:36 - Go MAEDA

- Related to Defect #24473: CSV Export Very slow for issues with lots of Custom Fields added

#5 - 2019-05-04 04:55 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

#6 - 2019-05-15 15:45 - Stephane Evr

Awesome!

#7 - 2019-06-25 06:53 - Koichi Tanimoto

Please let me know the following points:

1. Why do you skip filesize validation?

2. How do I remove attachment file after download finished. Can I remove it on browser?
#8 - 2019-06-27 08:12 - Jens Krämer

Good points, thanks for bringing them up.

1. Why do you skip filesize validation?

 We do this to avoid running into a filesize validation error in the background worker. We want these background exports to succeed even if the file

violates size constraints. We feel this is OK since the resulting files are only temporary and will not stay on the system for long time, anyway (see

below).

2. How do I remove attachment file after download finished. Can I remove it on browser?

 The resulting attachments are orphaned, without any container object. As such, they are fairly easy to detect and clean up i.e. by a cron job running

rake redmine:attachments:prune daily.

#9 - 2019-06-27 12:03 - Koichi Tanimoto

I understood above. Thanks your explaination!

#10 - 2019-09-28 00:33 - Go MAEDA

- Target version changed from 4.1.0 to 4.2.0

#11 - 2021-03-23 21:43 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#12 - 2022-02-23 23:00 - Marius BĂLTEANU

- Related to Feature #36691: Background job and dedicated status for project deletion added

#13 - 2022-03-20 22:24 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

Files

0001-introduces-IssueQuery-lazy_issues.patch 2.58 KB 2019-03-21 Jens Krämer

0002-implements-background-issue-PDF-and-CSV-exports.patch 21.4 KB 2019-03-21 Jens Krämer
